"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var sketch2json = require("sketch2json");
var validateGroup_1 = require("./utilities/validateGroup");
function validateLayers(layers, validators, pathPrefix) {
    return validateGroup_1.default(layers, validators, {
        getPath: function (_a) {
            var name = _a.name;
            return pathPrefix + "/" + name;
        },
        eachItem: function (layer) {
            if (layer.layers) {
                return validateLayers(layer.layers, validators, pathPrefix + "/" + layer.name);
            }
            return [];
        },
    });
}
function sketchlint(sketchData, validatorGroups) {
    return __awaiter(this, void 0, void 0, function () {
        var sketchJSON, pages, lintingErrors, pagesErrors, _i, pages_1, page, layers, name, layersErrors;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, sketch2json(sketchData)];
                case 1:
                    sketchJSON = _a.sent();
                    pages = Object.values(sketchJSON.pages);
                    lintingErrors = [];
                    if (validatorGroups.pages) {
                        pagesErrors = validateGroup_1.default(pages, validatorGroups.pages, {
                            getPath: function (_a) {
                                var name = _a.name;
                                return name;
                            },
                        });
                        lintingErrors = lintingErrors.concat(pagesErrors);
                    }
                    if (validatorGroups.layers) {
                        for (_i = 0, pages_1 = pages; _i < pages_1.length; _i++) {
                            page = pages_1[_i];
                            layers = page.layers, name = page.name;
                            layersErrors = validateLayers(layers, validatorGroups.layers, name);
                            lintingErrors = lintingErrors.concat(layersErrors);
                        }
                    }
                    return [2, lintingErrors];
            }
        });
    });
}
exports.default = sketchlint;
//# sourceMappingURL=sketchlint.js.map