"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function validateGroup(items, validators, _a) {
    var getPath = _a.getPath, eachItem = _a.eachItem;
    var errors = [];
    for (var _i = 0, items_1 = items; _i < items_1.length; _i++) {
        var item = items_1[_i];
        for (var _b = 0, _c = Object.keys(validators); _b < _c.length; _b++) {
            var ruleID = _c[_b];
            var validator = validators[ruleID];
            var error = validator(item);
            var path = getPath(item);
            if (eachItem) {
                errors = errors.concat(eachItem(item));
            }
            if (error) {
                errors.push({
                    ruleID: ruleID,
                    message: error[1],
                    type: error[0],
                    path: path,
                });
            }
        }
    }
    return errors;
}
exports.default = validateGroup;
//# sourceMappingURL=validateGroup.js.map